package jrummikub.control;

import jrummikub.model.GameSettings;
import jrummikub.util.IListener;
import jrummikub.util.IListener1;
import jrummikub.view.IView;
import jrummikub.view.IView.BottomPanelType;

/**
 * The application control controls the settings for a new games and create the
 * game control
 */
public class ApplicationControl {
	private SaveControl saveControl;
	private IView view;

	/**
	 * Creates a new application control
	 * 
	 * @param view
	 *          the view to use
	 */
	public ApplicationControl(IView view) {
		this.view = view;
		saveControl = new SaveControl(view);

		view.getMenuQuitEvent().add(new IListener() {
			@Override
			public void handle() {
				System.exit(0);
			}
		});
	}

	/**
	 * Starts the application by showing the game settings dialog panel
	 */
	public void startApplication() {
		view.showScorePanel(false);
		view.setBottomPanel(BottomPanelType.START_GAME_PANEL);
		SettingsControl settingsControl = new SettingsControl(view,
				new GameSettings());

		settingsControl.getStartGameEvent().add(new IListener1<GameSettings>() {
			@Override
			public void handle(GameSettings settings) {
				saveControl.setGameSettings(settings);

				GameControl gameControl = new GameControl(settings, saveControl, view);
				gameControl.getEndOfGameEvent().add(new IListener() {
					@Override
					public void handle() {
						startApplication();
					}
				});
				gameControl.startGame();

			}
		});
		settingsControl.startSettings();
	}
}
